/**
 * ai.jsx ©MaratShagiev m_js@bk.ru 01.08.2015
 */
try {
  indd_toCurvesViaAi ();
} catch ( e ) {
  alert ( 'Error Line: ' + e.line + '\n' + 'Error Message: ' + e.message, 'ERROR LINE && MESSAGE' );
}

function indd_toCurvesViaAi () {

  if ( !app.activeDocument.saved ) {
    alert ( 'Save the document' );
    return;
  }

  var packPath = pack ();

  if ( packPath == undefined ) {
    return;
  } else {
    app.activeDocument.close ();
    app.open ( (new File ( packPath )) );
  }

  addAiFunc ( getLastApp ( 'illustrator', 15, 30 ) );

  var linksAll = app.activeDocument.links,
      i, j,
      f,
      bt_ai,
      linksObj = {},
      linksStr = '';

  for ( i = 0, j = 0; i < linksAll.length; i++ ) {
    try {
      if (
        linksAll[ i ].linkXmp.creator.slice ( 0, 17 ) == 'Adobe Illustrator' ||
        linksAll[ i ].linkXmp.creator.slice ( 0, 10 ) == 'FrameMaker' ||
       linksAll[ i ].linkXmp.creator.slice ( 0, 14 ) == 'Adobe InDesign'
      ) {
        f = new File ( linksAll[ i ].filePath );
        linksObj[ f.fullName ] = j;
        j++;
      }
    } catch ( e ) {
      continue;
    }
  }

  for ( var key in linksObj ) {
    linksStr += key + ':::';
  }
  linksStr = linksStr.slice ( 0, -3 );

  bt_ai = new BridgeTalk ();
  bt_ai.target = getLastApp ( 'illustrator', 14, 50 );
  bt_ai.body = curvingAll.toString () +
    ";curvingAll('" + linksStr + "');";

  bt_ai.send ();


  /***************
   * THE LIBRARY *
   * *************/

  function curvingAll ( linksStr ) {
    var linksArr           = linksStr.split ( ':::' ),
        storeInteractLavel = app.userInteractionLevel;

    app.userInteractionLevel = UserInteractionLevel.DONTDISPLAYALERTS;

    for ( var i = 0; i < linksArr.length; i++ ) {
      var actualDoc = new File ( linksArr[ i ] )
      open ( actualDoc );
      _curving ();
      _closeDocs ( 1, activeDocument );
    }
    _notifyOnCompletion ();

    app.userInteractionLevel = storeInteractLavel;

    function _closeDocs ( saveOptsNumb /* 0 - don`t save; 1 - save; 2 - prompt*/, doc ) {

      var saveOptsArr = [ 'DONOTSAVECHANGES', 'SAVECHANGES', 'PROMPTTOSAVECHANGES' ],
          saveOpts    = SaveOptions[ saveOptsArr[ saveOptsNumb ] ];

      try {
        if ( arguments.length == 2 && arguments[ 1 ].typename == 'Document' ) {
          arguments[ 1 ].close ( saveOpts );
          return;
        } else if ( arguments.length == 1 ) {
          for ( var i = 0; i < documents.length; i++ ) {
            documents[ i ].close ( saveOpts );
            i--;
          }
          return;
        }
      } catch ( e ) {
        alert ( 'Error Line: ' + e.line + '\n' + 'Error Message: ' + e.message, 'ERROR LINE && MESSAGE' );
        return;
      }
    }

    function _curving () {

      for ( var i = 0; i < activeDocument.textFrames.length; i++ ) {
        var currentTextFrame = activeDocument.textFrames[ i ];
        if ( !_isEditable ( currentTextFrame ) ) continue;
        activeDocument.textFrames[ i ].createOutline ();
        i--;
      }

      function _isEditable ( elem ) {

        if ( arguments.length == 0 ) return false;

        if ( elem == undefined ) return true;

        if ( elem.typename == 'Document' )  return true;

        if ( isHide ( elem ) || isLock ( elem ) ) {
          return false;
        } else {
          elem = getParent ( elem );
          return _isEditable ( elem );
        }

        function getParent ( elem ) {
          return elem.parent;
        }

        function isLock ( elem ) {
          return elem.locked;
        }

        function isHide ( elem ) {
          if ( elem.typename == 'Layer' ) {
            return elem.visible == false;
          } else {
            return elem.hidden;
          }
        }
      }
    }

    function _notifyOnCompletion () {
      var bt_indd = new BridgeTalk ();
      bt_indd.target = 'indesign';
      bt_indd.body = 'alert("process complette")';
      bt_indd.send ();
    }
  }

  function pack () {
    var opts = {
      copyingFonts:          true,
      copyingLinkedGraphics: true,
      copyingProfiles:       true,
      updatingGraphics:      true,
      includingHiddenLayers: true,
      ignorePreflightErrors: true,
      forceSave:             true/*,
       packNearFolder:        true*/
    };

    return _pack ( opts );

    function _pack ( o ) {

      try {
        o = o || {};
        var fileName   = app.activeDocument.name.slice ( 0, -5 ),
            folderName = app.activeDocument.filePath;

        var copyingFonts          = o.copyingFonts || false,
            copyingLinkedGraphics = o.copyingLinkedGraphics || false,
            copyingProfiles       = o.copyingProfiles || false,
            updatingGraphics      = o.updatingGraphics || false,
            includingHiddenLayers = o.includingHiddenLayers || false,
            ignorePreflightErrors = o.ignorePreflightErrors || false,
            creatingReport        = o.creatingReport || false,
            versionComments       = o.versionComments || "comment",
            forceSave             = o.forceSave || false,
            packNearFolder        = o.packNearFolder || false,
            packPath              = false;

        if ( packNearFolder ) {
          packPath = new Folder ( folderName + "../../" + fileName + "/" );
          _makePack ();
//          alert ( 1 );
          return packPath + '/' + fileName + '.indd';
        } else {
          packPath = (new Folder ( app.activeDocument.fullName )).selectDlg ();
        }

        if ( packPath + '' == folderName ) {
          packPath = new Folder ( packPath + "/" + fileName + "/" );
          _makePack ();
//          alert ( 2 );
          return packPath + '/' + fileName + '.indd';
        }
        if ( packPath != null ) {
          packPath = new Folder ( packPath );
          _makePack ();
//          alert ( 3 );
          return packPath + '/' + fileName + '.indd';
        }

        function _makePack () {
          Folder ( packPath ).create ();
          app.activeDocument.packageForPrint (
            packPath,
            copyingFonts,
            copyingLinkedGraphics,
            copyingProfiles,
            updatingGraphics,
            includingHiddenLayers,
            ignorePreflightErrors,
            creatingReport,
            versionComments,
            forceSave
          );
        }
      } catch ( e ) {
        alert ( e.line + '\n' + e.message );
      }
    }
  }

  function getLastApp ( appName, appVersStart, appVersEnd ) {
    var lastAppName = '';
    for ( var i = appVersEnd; i >= appVersStart; i-- ) {
      lastAppName = BridgeTalk.getSpecifier ( appName + '-' + i );
      if ( lastAppName != null ) {
        return lastAppName;
      }
    }
    return lastAppName;
  }

  function addAiFunc ( aiName ) {
    $.level = 0;

    try {

      delete illustrator;
      illustrator = new Object;
      illustrator.revision = 1;
      illustrator.appName = "illustrator";
      illustrator.targetName = aiName;

      illustrator.ColorModeRGB = 0;
      illustrator.ColorModeCMYK = 1;

      illustrator.LibraryTypeArtwork = 0;
      illustrator.LibraryTypeSwatches = 1;
      illustrator.LibraryTypeBrushes = 2;
      illustrator.LibraryTypeGraphicStyles = 3;
      illustrator.LibraryTypeSymbols = 4;

      illustrator.open = function ( files ) {
        if ( BridgeTalk.appName == illustrator.appName ) {

          var fileArray = new Array;
          if ( files instanceof File ) {
            fileArray.push ( files );
          } else {
            fileArray = files.concat ( fileArray );
          }

          var reply = true;

          for ( var i = 0; i < fileArray.length; i++ ) {
            try {
              app.open ( fileArray[ i ] );
            } catch ( err ) {
              reply = false;
            }
          }
          return reply;
        } else {

          var filesString = illustrator.fileArrayToString ( files );

          var btMessage = new BridgeTalk;
          btMessage.target = illustrator.targetName;
          btMessage.body = "illustrator.open (" + filesString + ");";
          btMessage.send ();
        }
      }

      illustrator.quit = function () {
        if ( BridgeTalk.appName == illustrator.appName ) {
          try {
            app.quit ();
          }
          catch ( err ) {
          }
        }
        else {
          var btMessage = new BridgeTalk;
          btMessage.target = illustrator.targetName;
          btMessage.body = "illustrator.quit();";
          btMessage.send ();
        }
      }

      illustrator.fileArrayToString = function ( files ) {
        var fileArray = new Array;
        if ( files instanceof File ) {
          fileArray.push ( files );
        } else {
          fileArray = files.concat ( fileArray );
        }

        return fileArray.toSource ();
      }
    }
    catch ( e ) {}
  }

  function formatDate ( date ) {

    var dd = date.getDate ()
    if ( dd < 10 ) dd = '0' + dd;

    var mm = date.getMonth () + 1
    if ( mm < 10 ) mm = '0' + mm;

    var yy = date.getFullYear () % 100;
    if ( yy < 10 ) yy = '0' + yy;

    var hh = date.getHours ();
    if ( hh < 10 ) hh = '0' + hh;

    var mn = date.getMinutes ();
    if ( mn < 10 ) mn = '0' + mn;

    return dd + '.' + mm + '.' + yy + '   ' + hh + ':' + mn;
  }
}
